/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2008 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
#include "crvdraw.h"

void crvDrawRectangle (IplImage *img, CvRect *rect, 
					   int color, int thickness)
{
	CvPoint p1, p2;

	p1.x= rect->x;
	p1.y= rect->y;

	p2.x= p1.x + rect->width;
	p2.y= p1.y + rect->height;

	//cvRectangle (img, p1, p2, color, thickness);
	// OpenCV
	CvScalar esc= cvScalar ((double)color);
	cvRectangle (img, p1, p2, esc, thickness);
}

void crvDrawCross (IplImage *img, CvPoint point, int radius, int color, int thickness)
{
	CvPoint p1, p2;

	p1.x= point.x - radius;
	p1.y= point.y - radius;
	p2.x= point.x + radius;
	p2.y= point.y + radius;
//	cvLine (img, p1, p2, color, thickness);	
	cvLine (img, p1, p2, cvScalar ((double)color), thickness);	

	p1.x= point.x - radius;
	p1.y= point.y + radius;
	p2.x= point.x + radius;
	p2.y= point.y - radius;
	//cvLine (img, p1, p2, color, thickness);	
	cvLine (img, p1, p2, cvScalar ((double)color), thickness);	
}

void crvDrawCross2D32f (IplImage *img, CvPoint2D32f *point, 
						int radius,	int color, int thickness)
{
	CvPoint p;

	p.x= (int) (point->x + 0.5f);
	p.y= (int) (point->y + 0.5f);

	crvDrawCross (img, p, radius, color, thickness);
}
