/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#ifndef _CAMERADIALOG2_H_
#define _CAMERADIALOG2_H_


/*!
 * Includes
 */

////@begin includes
////@end includes
#include <wx/thread.h>
#include "camwindow2.h"
#include "crvcamera.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class CCamWindow2;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CAMERADIALOG2 10032
#define ID_PANEL3 10033
#define SYMBOL_CAMERADIALOG2_STYLE wxCAPTION|wxRESIZE_BORDER|wxTAB_TRAVERSAL
#define SYMBOL_CAMERADIALOG2_TITLE _("Camera Dialog")
#define SYMBOL_CAMERADIALOG2_IDNAME ID_CAMERADIALOG2
#define SYMBOL_CAMERADIALOG2_SIZE wxDefaultSize
#define SYMBOL_CAMERADIALOG2_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CameraDialog2 class declaration
 */

class CameraDialog2: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CameraDialog2 )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CameraDialog2();
    CameraDialog2( wxWindow* parent, wxWindowID id = SYMBOL_CAMERADIALOG2_IDNAME, const wxString& caption = SYMBOL_CAMERADIALOG2_TITLE, const wxPoint& pos = SYMBOL_CAMERADIALOG2_POSITION, const wxSize& size = SYMBOL_CAMERADIALOG2_SIZE, long style = SYMBOL_CAMERADIALOG2_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CAMERADIALOG2_IDNAME, const wxString& caption = SYMBOL_CAMERADIALOG2_TITLE, const wxPoint& pos = SYMBOL_CAMERADIALOG2_POSITION, const wxSize& size = SYMBOL_CAMERADIALOG2_SIZE, long style = SYMBOL_CAMERADIALOG2_STYLE );

    /// Destructor
    ~CameraDialog2();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CameraDialog2 event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_CAMERADIALOG2
    void OnCloseWindow( wxCloseEvent& event );

////@end CameraDialog2 event handler declarations

////@begin CameraDialog2 member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CameraDialog2 member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CameraDialog2 member variables
    CCamWindow2* m_camWindow;
////@end CameraDialog2 member variables
};

#endif
    // _CAMERADIALOG2_H_
