/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
#ifndef TESTPD_H
#define TESTPD_H

#include "oscinout.h"
#include "puredatapatch.h"
//#include "baseactivity.h"
//#include <osc/OscPacketListener.h>
//#include "SimpleShapeDrawer.h"
#include "valuerange.h"
//#include "playwithvoicedialog.h"

//class CTestPD :	public CBaseActivity, public osc::OscPacketListener
class CTestPD :	public osc::OscPacketListener
{
public:	
	CTestPD(); //wxThreadKind kind = wxTHREAD_DETACHED);
	virtual ~CTestPD(void);

	//virtual 
	void Start();
	void Finish();
//	void NotifyPathDied () { m_patchId.Clear(); }
	
	enum EPDTestType { TEST_PLAY_SOUND= 0, TEST_MICROPHONE };

	// Mic input
	//void setMicInputControl(int v) { m_micInputControl.setValue (v); SendOSCMsg ("/micInput", (float) v); }
	void setMicInputControl(int v) { 
		m_micInputControl.setValue (v); 		
		//SendOSCMsg ("/micInput", (float) v); 
		m_oscOut.SendSimpleMessage ("/micInput", (float) v);		
	}
	CValueRangeI* getMicInputControl() { return &m_micInputControl; }
	float getMicInputEnvelope() { return m_micInputEnvelope; }

	// Sound output
	void setOutputControl(int v) { 
		m_outputControl.setValue (v); 
		//SendOSCMsg ("/output", (float) v); 
		m_oscOut.SendSimpleMessage ("/output", (float) v); 

	}
	CValueRangeI* getOutputControl() { return &m_outputControl; }
	float getOutputEnvelope() { return m_outputEnvelope; }

	// Test type
	void setTestType (EPDTestType tt) { 
		if (tt== TEST_PLAY_SOUND) m_oscOut.SendSimpleMessage ("/test_play_sound", 0); //SendOSCMsg ("/test_play_sound", 0);
		else if (tt== TEST_MICROPHONE) m_oscOut.SendSimpleMessage ("/test_microphone", 0); // SendOSCMsg ("/test_microphone", 0);
	}
	
protected:
//	virtual void MainLoop(void);
//	virtual void OpenConfigDialog(void) {}
	virtual void ProcessMessage( const osc::ReceivedMessage& m, const IpEndpointName& remoteEndpoint );
private:

//	virtual void Delete() {}	// Disable delete call

	//UdpListeningReceiveSocket* m_socket;
	COscIn m_oscIn;
	COscOut m_oscOut;
	CPureDataPatch m_patch;

	CValueRangeI m_micInputControl;
	float m_micInputEnvelope;

	CValueRangeI m_outputControl;
	float m_outputEnvelope;	
};

#endif