/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
#pragma once

#include "oftracker.h"
#include "midicontroller.h"
#include "cameracontroller.h"
#include "valuerange.h"

class CVirtualInstrumentActivity : private CProcessImage2
{
public:
	CVirtualInstrumentActivity();
	~CVirtualInstrumentActivity();
	
	CValueRangeFExp* GetSensorRangePtr() { return &m_sensorSensitivy; }
	
	bool GetAutoDetectMotionArea () { return m_tracker.GetAutoTrack(); } //m_autoDetectMotionArea; }
	void SetAutoDetectMotionArea (bool val) { m_tracker.SetAutoTrack(val); } //{ m_autoDetectMotionArea= val; }

	unsigned char GetMusicalInstrument () { return m_musicalInstrumentGUI; }
	void SetMusicalInstrument (unsigned char val) { m_musicalInstrumentGUI= val; }

	int GetSelectedScore () { return m_selectedScore; }
	void SetSelectedScore (int val) { m_selectedScore= val; }

//	unsigned short GetNoteDuration () { return m_noteDuration; }
//	void SetNoteDuration (unsigned short val) { m_noteDuration= val; }
	CValueRangeUS* GetNoteDurationPtr() { return &m_noteDuration; }

	bool GetMutePreviousNote () { return m_mutePreviousNote; }
	void SetMutePreviousNote (bool val) { m_mutePreviousNote= val; }

private:
	virtual void ProcessImage (IplImage *pImage);

	// Settings
	CValueRangeFExp m_sensorSensitivy;
	//bool m_autoDetectMotionArea;
	unsigned char m_musicalInstrument;
	unsigned char m_musicalInstrumentGUI;
	int m_selectedScore;
	//unsigned short m_noteDuration;
	CValueRangeUS m_noteDuration;
	bool m_mutePreviousNote;

	// Operation
	CMidiOut m_midiOut;
	COfTracker m_tracker;
	CCameraProcessor m_camProcessor;

	// Current status
	unsigned char m_prevNote;
	double m_prevNoteTStamp;
	float m_currentNotePointer;
	
	
};
